﻿#include "pch.h"
#include "MainPage.xaml.h"
#include <ppltasks.h>

using namespace JukugoQuiz;

using namespace concurrency;
using namespace Platform;
using namespace Windows::ApplicationModel;
using namespace Windows::Foundation;
using namespace Windows::UI::Popups;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

Array<TextBlock^>^ TextBlocks = 
  ref new Array<TextBlock^>(16);
TextBox^ TextBoxAnswer;
Array<Button^>^ Buttons = ref new Array<Button^>(6);
std::vector<Word> Dictionary;
Word Answers[8];
char16 AnswerChar;

uint32 GetRandom(uint32 max) {
  if(max == 0) return 0;
  else {
    uint32 i = Windows::Security::Cryptography::
      CryptographicBuffer::GenerateRandomNumber();
    uint32 j = (uint32)((double)i * max / 
      MAXUINT32 + 0.5);
    return j;
  }
}

IAsyncOperation<IUICommand^>^ ShowMessage(String^ s) {
  auto md = ref new MessageDialog(s);
  return md->ShowAsync();
}

MainPage::MainPage() {
  InitializeComponent();
}

void MainPage::OnNavigatedTo(NavigationEventArgs^ e) {
  (void) e;	// 未使用のパラメーター

  const int cellSize = 130;
  const int myFontSize = 90;
  auto myFontFamily = ref new Windows::UI::Xaml::Media::FontFamily("ＭＳ 明朝");

  for (int i = 0; i < 16; i++) {
    auto cd = ref new ColumnDefinition();
    cd->Width = GridLength(cellSize);
    GridMain->ColumnDefinitions->Append(cd);

    auto rd = ref new RowDefinition();
    rd->Height = GridLength(cellSize);
    GridMain->RowDefinitions->Append(rd);
  }

  for(int i = 0; i < 16; i++) {
    auto tb = ref new TextBlock();
    tb->FontFamily = myFontFamily;
    tb->FontSize = myFontSize;
    tb->Foreground = ref new SolidColorBrush(Windows::UI::Colors::Black);
    switch (i) {
    case 8: case 15:
      tb->Text = L"↘";
      break;
    case 9: case 14:
      tb->Text = L"↓";
      break;
    case 10: case 13:
      tb->Text = L"↙";
      break;
    case 11: case 12:
      tb->Text = L"→";
      break;
    }

    switch (i) {
    case 0: case 1: case 2:
      tb->SetValue(Grid::ColumnProperty, i * 2);
      tb->SetValue(Grid::RowProperty, (Object^)0);
      break;
    case 3:
      tb->SetValue(Grid::ColumnProperty, (Object^)0);
      tb->SetValue(Grid::RowProperty, 2);
      break;
    case 4:
      tb->SetValue(Grid::ColumnProperty, 4);
      tb->SetValue(Grid::RowProperty, 2);
      break;
    case 5: case 6: case 7:
      tb->SetValue(Grid::ColumnProperty, 
        (i - 5) * 2);
      tb->SetValue(Grid::RowProperty, 4);
      break;
    case 8: case 9: case 10:
      tb->SetValue(Grid::ColumnProperty, i - 7);
      tb->SetValue(Grid::RowProperty, 1);
      break;
    case 11:
      tb->SetValue(Grid::ColumnProperty, 1);
      tb->SetValue(Grid::RowProperty, 2);
      break;
    case 12:
      tb->SetValue(Grid::ColumnProperty, 3);
      tb->SetValue(Grid::RowProperty, 2);
      break;
    case 13: case 14: case 15:
      tb->SetValue(Grid::ColumnProperty, i - 12);
      tb->SetValue(Grid::RowProperty, 3);
      break;
    }
    GridMain->Children->Append(tb);
    TextBlocks[i] = tb;
  }

  auto tba = ref new TextBox();
  tba->Width = cellSize - 20;
  tba->Height = cellSize - 30;
  tba->HorizontalAlignment = Windows::UI::Xaml::HorizontalAlignment::Left;
  tba->VerticalAlignment = Windows::UI::Xaml::VerticalAlignment::Top;
  tba->FontFamily = myFontFamily;
  tba->FontSize = myFontSize;
  tba->SetValue(Grid::ColumnProperty, 2);
  tba->SetValue(Grid::RowProperty, 2);
  GridMain->Children->Append(tba);
  TextBoxAnswer = tba;

  for (int i = 0; i < 6; i++) {
    auto b = ref new Button();
    switch (i) {
    case 0: case 3:
      b->Content = "これでどうだ！";
      b->Click += ref new RoutedEventHandler(this, &MainPage::ButtonSubmit_Click);
      break;
    case 1: case 4:
      b->Content = "降参です";
      b->Click += ref new RoutedEventHandler(this, &MainPage::ButtonGiveUp_Click);
      break;
    case 2: case 5:
      b->Content = "次の問題";
      b->Click += ref new RoutedEventHandler(this, &MainPage::ButtonNext_Click);
      break;
    }
    if (i < 3) {
      b->SetValue(Grid::RowProperty, i);
      GridRight->Children->Append(b);
    } else {
      b->SetValue(Grid::ColumnProperty, i - 3);
      GridBottom->Children->Append(b);
    }
    Buttons[i] = b;
  }

  auto t = create_task(Package::Current->
    InstalledLocation->GetFolderAsync(L"Data"));
  t.then([this](Windows::Storage::StorageFolder^ sFolder) {
    auto t = create_task(sFolder->GetFileAsync(
      L"Jukugo2c_utf8.txt"));
    t.then([this](Windows::Storage::StorageFile^ sFile) {
      auto t = create_task(
        Windows::Storage::FileIO::ReadTextAsync(sFile));
      t.then([this](String^ dicString) {
        const char16 *p = dicString->Begin();
        int i = 0;
        char16 line[30], column1[3], column2[27];
        column1[2] = L'\0';

        while(*p != NULL) {
          char16 c = *p;
          if (c == L'\n' || c == L'\r' || i > 28) { //ここ修正 5/10
            if (i > 0) {
              line[i] = L'\0';
              column1[0] = line[0];
              column1[1] = line[1];

              while (i > 2) {
                column2[i - 3] = line[i];
                i--;
              }
              Word w(ref new String(column1), 
                ref new String(column2));
              Dictionary.push_back(w);
            }
            i = 0;
          } else {
            line[i] = c;
            i++;
          }
          p++;
        }
        ShowQuestion();
      });
    });
  });
}

void MainPage::ShowQuestion() {
  TextBoxAnswer->Text = "";
  int candidateCount = 0;
  String^ selectedWord = "";
  char16 selectedChar = ' ';
  std::vector<Word> preCandidate;
  std::vector<Word> postCandidate;

  while(candidateCount < 4) {
    selectedWord = Dictionary[GetRandom(Dictionary.size() - 1)].Kanji;
    selectedChar = selectedWord->Data()[GetRandom(1)];
    preCandidate.clear();
    postCandidate.clear();

    for(unsigned int i = 0; i < Dictionary.size(); i++) 
      switch(Dictionary[i].Search(selectedChar)) {
      case SearchResult::Pre:
        preCandidate.push_back(Dictionary[i]);
        break;
      case SearchResult::Post:
        postCandidate.push_back(Dictionary[i]);
        break;
      }
    candidateCount = preCandidate.size() + postCandidate.size();
  }

  for(int i = 0; i < 8; i++) Answers[i].Char1 = L' ';

  if(preCandidate.size() > 4) {
    for(int i = 0; i < 4; i++) {
      auto index = GetRandom(preCandidate.size() - 1);
      Answers[i] = preCandidate[index];
      preCandidate.erase(preCandidate.begin() + index);
    } 
  } else {
    for(unsigned int i = 0; i < preCandidate.size(); i++)
      Answers[i] = preCandidate[i];
  }

  if(postCandidate.size() > 4) {
    for(int i = 0; i < 4; i++) {
      auto index = GetRandom(postCandidate.size() - 1);
      Answers[i + 4] = postCandidate[index];
      postCandidate.erase(postCandidate.begin() + index);
    } 
  } else
    for(unsigned int i = 0; i < postCandidate.size(); i++)
      Answers[i + 4] = postCandidate[i];

  for(int i = 0; i < 8; i++) {
    if(Answers[i].Char1 == L' ') 
      TextBlocks[i]->Text = L"●";
    else {
      int startIndex = 1;
      if(i < 4) startIndex = 0;
      TextBlocks[i]->Text = Answers[i].Kanji->Data()[startIndex].ToString();
    }
  }
  AnswerChar = selectedChar;
}

String^ GetAnswerString() {
  String^ s= "";
  for(int i = 0; i < 8; i++) {
    if(Answers[i].Char1 == L' ') continue;
    s = s + Answers[i].Kanji + L"（" + Answers[i].Yomi + L"）\n";
  }
  return s;
}

void MainPage::ButtonSubmit_Click(Object^ sender, RoutedEventArgs^ e) {
  String^ s = "";
  if(TextBoxAnswer->Text == AnswerChar.ToString())
    s = L"正解です！\n\n" + GetAnswerString();
  else s = L"違います";
  ShowMessage(s);
}

void MainPage::ButtonGiveUp_Click(Object^ sender, RoutedEventArgs^ e) {
  TextBoxAnswer->Text = AnswerChar.ToString();
  ShowMessage(L"答えは「" + AnswerChar + L"」です\n\n" + GetAnswerString());
}

void MainPage::ButtonNext_Click(Object^ sender, RoutedEventArgs^ e) {
  ShowQuestion();
}

void JukugoQuiz::MainPage::Page_SizeChanged(
  Platform::Object^ sender, 
  Windows::UI::Xaml::SizeChangedEventArgs^ e) {

  if(this->ActualHeight > this->ActualWidth) {
    GridRight->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
    GridBottom->Visibility = Windows::UI::Xaml::Visibility::Visible;
  } else {
    GridRight->Visibility = Windows::UI::Xaml::Visibility::Visible;
    GridBottom->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
  }
}
