#include "stdafx.h"

using namespace System;
using namespace System::Collections::Generic;
using namespace System::IO;
using namespace System::Text;
using namespace System::Text::RegularExpressions;

String^ ProcessOneFile(String^ fileName);
String^ Extract(String^ s);

int main(array<System::String ^> ^args) {
  String^ workFolder = L"C:\\work";
  array<String^>^ inputFiles = {
    L"Noun.adjv.dic", L"Noun.adverbal.dic",
    L"Noun.demonst.dic", L"Noun.dic",
    L"Noun.nai.dic", L"Noun.others.dic",
    L"Noun.verbal.dic"};

  auto sb = gcnew StringBuilder();
  for each (auto inputFile in inputFiles)
    sb->Append(ProcessOneFile(Path::Combine(workFolder, inputFile)));

  auto list1 = sb->ToString()->Split(gcnew array<String^>{L"\r\n"}, 
    StringSplitOptions::RemoveEmptyEntries);
  auto list2 = gcnew List<String^>();

  for each (String^ line in list1) {
    auto columns = line->Split(L',');
    if(columns[0]->Length == 2) {
      if(Regex::IsMatch(columns[0], L"\\p{IsHiragana}")) continue;
      if(Regex::IsMatch(columns[0], L"\\p{IsKatakana}")) continue;
      if(Regex::IsMatch(columns[0], 
        L"[PQRSTUVWXO`abcdefgh" +
        L"ijklmnopqrstuwxy" +
        L"YZ]")) continue;
      if (columns[0][0] == columns[0][1]) continue;
      list2->Add(Regex::Replace(line, L"[{}]", L""));
    }
  }
  auto shouldRemove = gcnew List<int>();
  list2->Sort();

  for(int i = 0; i < list2->Count; i++) 
    for(int j = i + 1; j < list2->Count; j++) {
      if(list2[i] != list2[j]) break;
      else shouldRemove->Add(j);
    }

  shouldRemove->Sort();
  for(int i = shouldRemove->Count - 1; i > -1; i--)
    list2->RemoveAt(shouldRemove[i]);

  sb->Clear();
  for each (String^ line in list2) sb->AppendLine(line);

  File::WriteAllText(Path::Combine(workFolder, L"Jukugo2c_utf8.txt"),
    sb->ToString(), Encoding::GetEncoding("UTF-8"));
  Console::WriteLine(L"I܂");
  return 0;
}

String^ ProcessOneFile(String^ fileName) {
  auto input = File::ReadAllText(fileName, Encoding::GetEncoding(L"Shift_JIS"));
  auto lines = input->Split(gcnew array<String^>{L"\r\n"},  
    StringSplitOptions::RemoveEmptyEntries);
  auto result = gcnew StringBuilder();
  for each (String^ line in lines)
    result->AppendLine(Extract(line));
  return result->ToString();
}

String^ Extract(String^ s) {
  s = Regex::Replace(s, L"^.*o\\s\\(", "");
  s = Regex::Replace(s, L"\\s.*ǂ\\s", ",");
  s = Regex::Replace(s, L"\\).*$", "");
  return s;
}
