﻿#include "pch.h"
#include "MainPage.xaml.h"
#include <ppltasks.h>

using namespace SimpleView;
using namespace concurrency;
using namespace Platform;
using namespace Windows::Storage;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;

MainPage::MainPage() {
  InitializeComponent();
}

void MainPage::OnNavigatedTo(NavigationEventArgs^ e) {
  (void) e; // 未使用のパラメーター

  ScrollViewerMain->VerticalScrollBarVisibility =
    ScrollBarVisibility::Auto;
  ScrollViewerMain->HorizontalScrollBarVisibility = 
    ScrollBarVisibility::Auto;
}

void SimpleView::MainPage::ButtonOpen_Click(
  Platform::Object^ sender, 
  Windows::UI::Xaml::RoutedEventArgs^ e) {

  auto fop = ref new Pickers::FileOpenPicker();
  fop->FileTypeFilter->Append(L".jpg");
  fop->FileTypeFilter->Append(L".jpeg");
  fop->FileTypeFilter->Append(L".bmp");

  auto t = create_task(fop->PickSingleFileAsync());
  t.then([this](StorageFile^ sFile) {
    if(sFile != nullptr) {
      auto t = create_task(sFile->OpenAsync(
        FileAccessMode::Read));
      t.then([this](
        Streams::IRandomAccessStream^ stream) {
        auto bi = ref new Imaging::BitmapImage();
        bi->SetSource(stream);
        ImageMain->Source = bi;
      });
    }
  });
}

void SimpleView::MainPage::ButtonResetSize_Click(
  Platform::Object^ sender, 
  Windows::UI::Xaml::RoutedEventArgs^ e) {

  ScrollViewerMain->ZoomToFactor(1);
}

void SimpleView::MainPage::
  ScrollViewerMain_ViewChanged(
  Platform::Object^ sender, 
  Windows::UI::Xaml::Controls::
  ScrollViewerViewChangedEventArgs^ e) {

  auto s = ScrollViewerMain->ZoomFactor.ToString();

    
  const int size = 100;
  char16 buffer[size];
  swprintf_s(buffer, size, L"%.2f", 
    ScrollViewerMain->ZoomFactor);
  String^ s = ref new String(buffer);
  TextBlockZoom->Text = L"ズーム：" + s;
}

void SimpleView::MainPage::
  ScrollViewerMain_LayoutUpdated(
  Platform::Object^ sender, Platform::Object^ e) {

  ScrollViewerMain->MaxWidth = this->ActualWidth;
}
