﻿using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;

namespace SimpleView {
  public sealed partial class MainPage : Page {
    public MainPage() {
      this.InitializeComponent();
    }

    protected override void OnNavigatedTo(
      NavigationEventArgs e) {

      ScrollViewerMain.VerticalScrollBarVisibility =
          ScrollBarVisibility.Auto;
      ScrollViewerMain.HorizontalScrollBarVisibility = 
        ScrollBarVisibility.Auto;
    }

    private async void ButtonOpen_Click(
      object sender, RoutedEventArgs e) {

      var fop = new Windows.Storage.Pickers.
        FileOpenPicker();
      fop.FileTypeFilter.Add(".jpg");
      fop.FileTypeFilter.Add(".jpeg");
      fop.FileTypeFilter.Add(".bmp");

      var sFile = await fop.PickSingleFileAsync();
      if (sFile != null) {
        var stream = await sFile.OpenAsync(
          Windows.Storage.FileAccessMode.Read);
        var bi = new Windows.UI.Xaml.Media.Imaging.
          BitmapImage();
        bi.SetSource(stream);
        ImageMain.Source = bi;
      }
    }

    private void ButtonResetSize_Click(
      object sender, RoutedEventArgs e) {

      ScrollViewerMain.ZoomToFactor(1);
    }

    private void ScrollViewerMain_ViewChanged(
      object sender,
      ScrollViewerViewChangedEventArgs e) {

      TextBlockZoom.Text = "ズーム：" + 
        ScrollViewerMain.ZoomFactor.ToString("F2");
    }

    private void ScrollViewerMain_LayoutUpdated(
      object sender, object e) {

      ScrollViewerMain.MaxWidth = this.ActualWidth;
    }
  }
}
