﻿Imports System.IO
Imports System.Text
Imports System.Text.RegularExpressions

Public Class Form1
  Private WorkFolder As String = "C:\work"
  Private InputFiles() As String = New String() {
    "Noun.adjv.dic", "Noun.adverbal.dic",
    "Noun.demonst.dic", "Noun.dic",
    "Noun.nai.dic", "Noun.others.dic",
    "Noun.verbal.dic"}
  Private InEncoding =
    Encoding.GetEncoding("Shift_JIS")
  Private OutEncoding =
    Encoding.GetEncoding("UTF-8")

  Private Sub ButtonExtract_Click(sender As Object,
    e As EventArgs) Handles ButtonExtract.Click

    Dim sb As New StringBuilder()
    For Each inputFile In InputFiles
      sb.Append(ProcessOneFile(Path.Combine(
        WorkFolder, inputFile)))
    Next

    Dim list1 = sb.ToString().Split(
      New String() {vbCrLf},
      StringSplitOptions.RemoveEmptyEntries)
    Dim list2 = New List(Of String)

    For Each line In list1
      Dim columns = line.Split(","c)
      If columns(0).Length = 2 Then
        If Regex.IsMatch(columns(0), "\p{IsHiragana}"
          ) Then Continue For
        If Regex.IsMatch(columns(0), "\p{IsKatakana}"
          ) Then Continue For
        If Regex.IsMatch(columns(0),
          "[１２３４５６７８９０ＡＢＣＤＥＦＧＨＩ" &
          "ＪＫＬＭＮＯＰＱＲＳＴＵＶＸＹＺ" &
          "αβγｉｎ〆〇]"
          ) Then Continue For
        If columns(0)(0) = columns(0)(1) Then _
          Continue For
        list2.Add(Regex.Replace(line, "[{}]", ""))
      End If
    Next

    Dim shouldRemove As New List(Of Integer)
    list2.Sort()

    For i = 0 To list2.Count - 1
      For j = i + 1 To list2.Count - 1
        If list2(i) <> list2(j) Then
          Exit For
        Else
          shouldRemove.Add(j)
        End If
      Next
    Next

    shouldRemove.Sort()
    For i = shouldRemove.Count - 1 To 0 Step -1
      list2.RemoveAt(shouldRemove(i))
    Next

    sb.Clear()
    'Dim lengthMax = 0
    For Each line In list2
      'If line.Length > lengthMax Then
      '  lengthMax = line.Length
      '  Debug.WriteLine(lengthMax.ToString() & ":" & line)
      'End If
      sb.AppendLine(line)
    Next

    File.WriteAllText(
      Path.Combine(WorkFolder, "Jukugo2c_utf8.txt"),
      sb.ToString(), OutEncoding)
    MsgBox("処理を終えました")
  End Sub

  Private Function ProcessOneFile(
    fileName As String) As String

    Dim input = File.ReadAllText(fileName, InEncoding)
    Dim lines = input.Split(New String() {vbCrLf},
      StringSplitOptions.RemoveEmptyEntries)
    Dim result As New StringBuilder()

    For Each line In lines
      result.AppendLine(Extract(line))
    Next
    Return result.ToString()
  End Function

  Private Function Extract(s As String) As String
    s = Regex.Replace(s, "^.*見出し語\s\(", "")
    s = Regex.Replace(s, "\s.*読み\s", ",")
    s = Regex.Replace(s, "\).*$", "")
    Return s
  End Function
End Class
